package main;

import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.management.Query;

import model.Dobavljac;
import model.Proizvod;
import org.hibernate.HibernateException;


import org.hibernate.Session;
import org.hibernate.search.FullTextSession;
import org.hibernate.search.Search;
import org.hibernate.search.query.dsl.QueryBuilder;

import util.HibernateUtility;

public class Main {

    /**
     * @param args
     */
    public static void main(String[] args) throws HibernateException {
        Main m = new Main();
        
        List<Dobavljac> dobavljaci=m.pronadjiDobavljaceFullText("čačak кремпита");//Чачак Котор //Čačak Котор //кремпита
        System.out.println(dobavljaci);
        HibernateUtility.getSessionFactory().close();
    }

    public List<Dobavljac> pronadjiDobavljaceFullText(String keyword) {
        List dobavljaci = null;
        try {
            //otvaranje sesije
            Session session = HibernateUtility.getSessionFactory().openSession();
            //kreiranje sesije za FullText upite
            FullTextSession fullTextSession = Search.getFullTextSession(session);
            //pravljenje/osvjezavanje indeksera
            fullTextSession.createIndexer().startAndWait();
            
            //pocetak transakcije
            fullTextSession.beginTransaction();
            QueryBuilder qb = fullTextSession.getSearchFactory().buildQueryBuilder().forEntity(Dobavljac.class).get();
            //pravljenje Lucene upita
            org.apache.lucene.search.Query luceneQuery = qb
                    .keyword()
                    .onFields("naziv", "adresa", "proizvodi.naziv")
                    .matching(keyword)
                    .createQuery();

            // konveryija Lucene upita u Query
            org.hibernate.Query query = fullTextSession.createFullTextQuery(luceneQuery, Dobavljac.class);

            // izvrsenje upita
            dobavljaci = query.list();
            return dobavljaci;
            
        } catch (InterruptedException ex) {
            Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
        }
            
        return dobavljaci;
    }
    
}
