package model;

import javax.persistence.Entity;
import javax.persistence.Id;
import org.hibernate.search.annotations.Analyze;
import org.hibernate.search.annotations.Analyzer;
import org.hibernate.search.annotations.Field;
import org.hibernate.search.annotations.Index;
import org.hibernate.search.annotations.Indexed;
import org.hibernate.search.annotations.Store;







@Entity
@Indexed
public class Proizvod {
		
	@Id
	    private int proizvodID;
            @Field(index=Index.YES, analyze=Analyze.YES, store=Store.NO)  
            @Analyzer(definition = "customanalyzer")
	    private String naziv;
	    private double cena;
	    
	    public Proizvod() {
	    }
	    
	    public Proizvod(int proizvodID, String naziv, double cena) {
	        this.proizvodID=proizvodID;
	        this.naziv=naziv;
	        this.cena=cena;
	    }

	    public String getNaziv() {
	        return naziv;
	    }

	    public void setNaziv(String naziv) {
	        this.naziv = naziv;
	    }

	    public double getCena() {
	        return cena;
	    }

	    public void setCena(double cena) {
	        this.cena = cena;
	    }
	    
	    public String toString(){
	        return "ProizvodID: "+getProizvodID()+"\tNaziv: "+naziv+"\tCena: "+cena;
	    }

	    public int getProizvodID() {
	        return proizvodID;
	    }

	    public void setProizvodID(int proizvodID) {
	        this.proizvodID = proizvodID;
	    }
	    
}
